#!/usr/bin/python3

from math import ceil
from Crypto.Util.number import *
from pwn import xor

S = [2, 0, 3, 1, 5, 4, 7, 6]
SIZE = 32

## f : list -> bytes
def f(inp):
    res = 0
    for j in range(0, len(inp)):
        for i in range(8):
            res = res << 1 | ((inp[j] >> S[i]) & 1)

    res2 = 0
    for i in range(8):
        for j in range(0, len(inp)):
            res2 = res2 << 1 | ( (res >> (8*(len(inp)-1-j)+7-i)) & 1)

    return bytes([(((res2 >> 8*j) & 0xff) >> 4) | (((res2 >> 8*j) & 0xf) << 4) for j in range(len(inp))]).rjust(SIZE, b'\x00')


# gera_token_aux : str x bytes x int -> bytes
def gera_token_aux(username, seed, tick):
    seed = f([a^b for a,b in zip(seed, username.encode().rjust(SIZE, b'\x00'))])
    for i in range(tick):
        seed = f([a^b for a,b in zip(seed, username.encode().rjust(SIZE, b'\x00'))])
    return seed


# gera_token : str x bytes x int -> int
def gera_token(username, seed, tick):
    return bytes_to_long(gera_token_aux(username, seed, tick))

def f_inv(reversed_res2,size):
    reversed_res2 = bytes_to_long(reversed_res2)
    reversed_res2 = [(((reversed_res2 >> 8*j) & 0xff) >> 4) | (((reversed_res2 >> 8*j) & 0xf) << 4) for j in range(size)]

    reversed_res2 = list(map(lambda x: list(bin(x)[2:].rjust(8,'0')),reversed_res2))

    reversed_res2 = [list(map(int,l)) for l in reversed_res2]
    reversed_resaux = []
    for l in reversed_res2:
        reversed_resaux += l
    reversed_res2 = reversed_resaux

    reversed_res = [[0 for _ in range(8)] for i in range(size)]
    ctr = 0            
    for i in range(8):
        for j in range(size):
            reversed_res[j][i] = reversed_res2[ctr]
            ctr += 1

    inp = [[0 for _ in range(8)] for i in range(size)]
    for j in range(size):
        for i in range(8):
            inp[j][7-S[i]] = reversed_res[j][i]
                

    ret = []
    for l in inp:
        ret.append(int(''.join(map(str,l)),2))
    return ret

def crack(seed,username,tick):
    seed = long_to_bytes(seed)
    for i in range(tick+1):
        seed = xor(f_inv(seed,32),username.rjust(SIZE,b'\x00'))
    return seed

#print(crack(99953146222872330969242131293482236024026713792799960991549303402969431883226,b"bruno",10773))
#print(crack(8302164812878360759168450721899078191238762237916607449902568016057432228090,b"bruno3",10917))

seed_bruno = b'\xf0\x97>\xbe\x15\x89\x17\x01s;\xf0K\xcfY\x07&x>\xa8\x80l\x96\xc7\xdf\xd9v\xf8)u)A\xd4'
#seed_bruno3 = b'\xf0\x97>\xbe\x15\x89\x17\x01s;\xf0K\xcfY\x07&x>\xa8\x80l\x96\xc7\xdf\xd9v\x9a9r2@\x88'

seed_admin = xor(seed_bruno,b"admin".rjust(SIZE,b'\x00'), b"bruno".rjust(SIZE,b'\x00'))

tick = 10923 

print(gera_token("admin",seed_admin,tick))
